!--------( AMEQS : <ameqs> inversion )--------
  implicit none
  integer,parameter :: KVER = 2018
  integer :: lwkdir, lrtrim
  real,allocatable :: f(:,:), r(:,:), q(:,:), g(:,:)
  real,allocatable :: s(:,:), p(:,:), v(:,:), t(:,:)
  character(80) :: wdr, flog, fnam1, fnam2, fnam3, buf
  character(72) :: out;  character(20) :: sdtm
  character(8) :: area, area1, salt
  integer :: ldr, i, j, klp, nlp, nloop, l, ic, jc, n, nver, IER
  integer :: nc, ncc, iorg, korg, ispa, ispb
  integer :: nc1, ncc1, iorg1, korg1, ispa1, ispb1
  integer :: ixsf, iysf, mszxf, mszyf, mxf, myf
  integer :: ixs1, iys1, mszx1, mszy1, mx1, my1
  integer :: ixl, iyl, mszx, mszy, mx, my, nhx, nhy, nfx, nfy
  integer :: ixlm, iylm, mxm, mym, ixl1, iyl1, mxm1, mym1, ip, jp
  real :: vnul, alt, alt1, hw, hwm, vd, xsf, ysf, xl, yl, xlm, ylm, anul
  real :: dmy, pvv, pvvp, a, pqq, tnul, ds, ss, dv, dip, dec, the, phi

  call premsg('AMEQS : <ameqs> inversion')
  call opnpin()
  ldr = lwkdir(50,wdr) + 1
  flog = wdr;  fnam1 = wdr;  fnam2 = wdr;  fnam3 = wdr
  call gparma('Enter LOG filename ==> ', 81-ldr, flog(ldr:80))
  call gparma('Enter AM mesh data filename       ==> ', 81-ldr, fnam1(ldr:80))
  open(1,file=fnam1,status='old')
  do
    read(1,'(a)') buf
    if(buf(1:1) /= '#') exit
  enddo
  if (buf(13:16) == '    ') then        !-- v2005
    read(buf,'(a8,i4,4x,4i8)') area, ncc, iorg, korg, ispa, ispb
    if ((ncc<0) .or. (ncc>=400)) call abendm('invalid coord.no.')
    nc = ncc
    if (ncc < 200) then
      nc = ncc; ncc = nc + 800
    else
      ncc = ncc - 200; nc = ncc
    endif
  else                                  !-- v2018
    read(buf,'(a8,4x,i4,4i8)') area, ncc, iorg, korg, ispa, ispb
    nc = ncc
    if ((ncc >= 800) .and. (ncc < 1000)) nc = ncc - 800
  endif
  if ((nc >= 1) .and. (nc <= 62)) then
    iorg = 0;  ispa = 0;  ispb = 0
    korg = (nc-30)*360 - 180
    if(nc > 60) korg = 0
    if(nc == 61) iorg = +5400
    if(nc == 62) iorg = -5400
  endif
  read(1,'(a)') buf
  read(buf,*) ixsf, iysf, mszxf, mszyf, mxf, myf, vnul, alt
  if ((mxf <= 0) .or. (myf <= 0)) call abendm('illegal array size')

  allocate(f(mxf,myf));  allocate(r(mxf,myf));  allocate(q(mxf,myf))

  read(1,*) ((f(i,j),i=1,mxf),j=1,myf)
  close(1)

  call gparma('Enter CMUPS matrix data filename ==> ', 81-ldr, fnam2(ldr:80))
  open(20,file=fnam2,form='unformatted',status='old')
  read(20) area1, nver, ncc1, iorg1,korg1, ispa1,ispb1,   &
          ixs1, iys1, mszx1, mszy1, mx1, my1, alt1,   &
          ixl,  iyl,  mszx,  mszy,  mx,  my,   &
          nhx, nhy, hw, vd
  if (nver /= KVER) call abendm('Version mismatch')
  if (alt < 0.) alt = alt1
  if ((area1 /= area) .or. (ncc1 /= ncc) .or. (iorg1 /= iorg) .or.   &
      (korg1 /= korg) .or. (ispa1 /= ispa) .or. (ispb1 /= ispb))   &
    call abendm('Header inconsistent')
  if ((ixs1 /= ixsf) .or. (iys1 /= iysf) .or. (mszx1 /= mszxf) .or.   &
      (mszy1 /= mszyf) .or. (mx1 /= mxf) .or. (my1 /= myf))   &
    call abendm('Header inconsistent')
  hwm = hw * 1000.
  if ((nint(hwm/float(mszx)) /= nhx) .or. (nint(hwm/float(mszy)) /= nhy))   &
    call abendm('CMUPS file broken')
  write(salt,'(1x,f7.0)') alt
  if (alt == 0.) salt = '    var.'
  if (alt < 0.)  salt = '   undef'
  xsf = float(ixsf)/1000.;  ysf = float(iysf)/1000.
  xl = float(ixl)/1000.;  yl = float(iyl)/1000.
  ixlm = ixl - mszx*nhx;  iylm = iyl - mszy*nhy
  xlm = float(ixlm)/1000.;  ylm = float(iylm)/1000.
  mxm = mx + nhx + nhx;  mym = my + nhy + nhy
  if ((mx <= 0) .or. (my <= 0)) call abendm('illegal array size')
  if ((nhx < 10) .or. (nhy < 10)) call abendm('truncation too short')
  nfx = nhx + 1 + nhx;  nfy = nhy + 1 + nhy

  allocate(s(mxm,mym)); allocate(p(mxm,mym))
  allocate(v(mxm,mym)); allocate(t(mxm,mym))
  allocate(g(nfx,nfy))

  write(out,'(a12,a8,6x,a6,i4,4x,4i8)')   &
    '--- Area :  ', area, 'Coord.', ncc, iorg,korg, ispa,ispb
  call premsg(out)
  write(out,'(a14,2a10,2x,2a8,2a6,a8)')   &
    '---   (mesh)  ', 'xs', 'ys', 'msz-x', 'msz-y', 'mx', 'my', 'alt '
  call premsg(out)
  write(out,'(a16,2f10.2,2i8,2i6,a8)')   &
    '--- mag. obs.   ', xsf,ysf, mszxf,mszyf, mxf,myf, salt
  call premsg(out)
  write(out,'(a16,2f10.2,2i8,2i6,a8)')   &
    '--- reduc.surf. ', xl, yl,  mszx,mszy, mx, my, '    --- '
  call premsg(out)
  write(out,'(a16,2f10.2,2i8,2i6,a8)')   &
    '--- equiv.source', xlm,ylm, mszx,mszy, mxm,mym, '    var.'
  call premsg(out)

  call gparma('Enter AMEQS model in/out filename==> ', 81-ldr, fnam3(ldr:80))
  open(21,file=fnam3,status='old')
  do
    read(21,'(a)') buf
    if (buf(1:1) /= '#') exit
  enddo
  if (buf(13:16) == '    ') then        !-- v2005
    read(buf,'(a8,i4,4x,4i8)') area1, ncc1, iorg1,korg1, ispa1,ispb1
    if ((ncc1<0) .or. (ncc1>=400)) call abendm('invalid coord.no.')
    nc1 = ncc1
    if (ncc1 < 200) then
      nc1 = ncc1; ncc1 = nc1 + 800
    else
      ncc1 = ncc1 - 200; nc1 = ncc1
    endif
  else                                  !-- v2018
    read(buf,'(a8,4x,i4,4i8)') area1, ncc1, iorg1,korg1, ispa1,ispb1
    nc1 = ncc1
    if ((ncc1 >= 800) .and. (ncc1 < 1000)) nc1 = ncc1 - 800
  endif
  if ((nc1 >= 1) .and. (nc1 <= 62)) then
    iorg1 = 0;  ispa1 = 0;  ispb1 = 0
    korg1 = (nc1-30)*360 - 180
    if (nc1 > 60) korg1 = 0
    if (nc1 == 61) iorg1 = +5400
    if (nc1 == 62) iorg1 = -5400
  endif
  read(21,'(a)') buf
  read(buf,*) ixl1, iyl1, mszx1, mszy1, mxm1, mym1, anul, dmy, klp
  if ((area1 /= area) .or. (ncc1 /= ncc) .or. (iorg1 /= iorg)   &
      .or. (korg1 /= korg) .or. (ispa1 /= ispa) .or. (ispb1 /= ispb))   &
    call abendm('Header inconsistent')
  if ((ixl1 /= ixlm) .or. (iyl1 /= iylm) .or. (mszx1 /= mszx)   &
      .or. (mszy1 /= mszy) .or. (mxm1 /= mxm) .or. (mym1 /= mym))   &
    call abendm('Header inconsistent')
  read(21,*) ((s(i,j),i=1,mxm),j=1,mym)
  do
    read(21,'(a)') buf
    if (buf(1:1) /= '#') exit
  enddo
  if (buf(13:16) == '    ') then        !-- v2005
    read(buf,'(a8,i4,4x,4i8)') area1, ncc1, iorg1,korg1, ispa1,ispb1
    if ((ncc1<0) .or. (ncc1>=400)) call abendm('invalid coord.no.')
    nc1 = ncc1
    if (ncc1 < 200) then
      nc1 = ncc1; ncc1 = nc1 + 800
    else
      ncc1 = ncc1 - 200; nc1 = ncc1
    endif
  else                                  !-- v2018
    read(buf,'(a8,4x,i4,4i8)') area1, ncc1, iorg1,korg1, ispa1,ispb1
    nc1 = ncc1
    if ((ncc1 >= 800) .and. (ncc1 < 1000)) nc1 = ncc1 - 800
  endif
  if ((nc1 >= 1) .and. (nc1 <= 62)) then
    iorg1 = 0;  ispa1 = 0;  ispb1 = 0
    korg1 = (nc1-30)*360 - 180
    if (nc1 > 60) korg1 = 0
    if (nc1 == 61) iorg1 = +5400
    if (nc1 == 62) iorg1 = -5400
  endif
  read(21,'(a)') buf
  read(buf,*) ixl1, iyl1, mszx1, mszy1, mxm1, mym1, tnul
  if ((area1 /= area) .or. (ncc1 /= ncc) .or. (iorg1 /= iorg)   &
      .or. (korg1 /= korg) .or. (ispa1 /= ispa) .or. (ispb1 /= ispb))   &
    call abendm('Header inconsistent')
  if ((ixl1 /= ixlm) .or. (iyl1 /= iylm) .or. (mszx1 /= mszx)   &
      .or. (mszy1 /= mszy) .or. (mxm1 /= mxm) .or. (mym1 /= mym))   &
    call abendm('Header inconsistent')
  read(21,*) ((t(i,j),i=1,mxm),j=1,mym)
  read(21,'(2x,4f8.1)') dip, dec, the, phi
  rewind(21)

  call premsg('How many loops to excute ?')
  call gparmi('   (minus to restart from loop-0) ==> ', nloop)
  nlp = iabs(nloop)
  call clspin()
  call strdtm(sdtm)

  call dpcini('... read CMUPS matrix (0) : ')
  do jp=1,myf; do ip=1,mxf
    read(20) i,j, ic,jc, g
    if ((i /= ip) .or. (j /= jp)) call abendm('CMUPS file broken')
    call dpcent((jp-1)*mxf+ip, mxf*myf)
  enddo; enddo
  rewind(20)

  write(6,'(a)')   '----------------------------------------'
  write(6,'(a)')   'AMEQS : <ameqs> inversion'
  write(6,'(a,a)') ' AM mesh data infile    : ', fnam1(1:lrtrim(fnam1))
  write(6,'(a,a)') ' CMUPS matrix infile    : ', fnam2(1:lrtrim(fnam2))
  write(6,'(a,a)') ' AMEQS model i/o file   : ', fnam3(1:lrtrim(fnam3))
  write(6,'(a12,a8,6x,a6,i4,4x,4i8)')   &
    'Areaname :  ', area, 'Coord.', ncc, iorg, korg, ispa, ispb
  write(6,'(4x,a)')   &
    '  (mesh)          xs        ys     msz-x   msz-y    mx    my    alt '
  write(6,'(4x,a12,2f10.2,2i8,2i6,a8)')   &
    'mag. obs.   ', xsf,ysf, mszxf,mszyf, mxf,myf, salt
  write(6,'(4x,a12,2f10.2,2i8,2i6,a8)')   &
    'reduc. surf.', xl, yl,  mszx,mszy, mx, my, '    --- '
  write(6,'(4x,a12,2f10.2,2i8,2i6,a8)')   &
    'eq.src.anom.', xlm,ylm, mszx,mszy, mxm,mym, '    var.'
  write(6,'(a,f6.2,a,i4,a,i4,a)')   &
    ' Half width of calc.window :', hw, ' km (', nhx, ' *', nhy, '  mesh )'
  write(6,'(a,f8.1,a)')   &
    ' Equiv.Source :', vd, ' m below Reduction alt.'
  write(6,'(a,i4)') ' Max. Loop count :', nloop

  if (nloop < 0) then
    klp = 0
    do j=1,mym; do i=1,mxm;  s(i,j) = 0.; p(i,j) = 0.;  enddo; enddo
    ds = 0.
  else
    ss = 0.
    do j=1,mym; do i=1,mxm
      if (t(i,j) /= tnul) ss = ss + s(i,j)*s(i,j)
      p(i,j) = 0.
    enddo; enddo
    ds = sqrt(ss / float(mxm*mym))
  endif

  call conv1(g,nfx,nfy, s,mxm,mym, r,mxf,myf)
  n = 0;  ss = 0.
  do j=1,myf; do i=1,mxf
    if (f(i,j) == vnul) then
      r(i,j) = 0.
    else
      r(i,j) = f(i,j) - r(i,j)
      ss = ss + r(i,j)*r(i,j)
      n = n + 1
    endif
  enddo; enddo
  dv = sqrt(ss / float(n))
  write(6,'(a,i4,a,f8.2,a,f7.2)')   &
    ' loop', klp, '   rms.Step :', ds, '   rms.Residual :', dv
  open(9,status='scratch')
  write(9,*) klp, ds, dv

  pvv = 1.
  do l=1,nlp
    klp = klp + 1;  pvvp = pvv
    call conv2(g,nfx,nfy, r,mxf,myf, v,mxm,mym)
    pvv = 0.
    do j=1,mym; do i=1,mxm;  pvv = pvv + v(i,j)*v(i,j);  enddo; enddo
    a = pvv / pvvp
    do j=1,mym; do i=1,mxm;  p(i,j) = v(i,j) + a*p(i,j);  enddo; enddo
    call conv1(g,nfx,nfy, p,mxm,mym, q,mxf,myf)
    pqq = 0.
    do j=1,myf; do i=1,myf; pqq = pqq + q(i,j)*q(i,j);  enddo; enddo
    a = pvv / pqq;  ss = 0.
    do j=1,mym; do i=1,mxm
      s(i,j) = s(i,j) + a*p(i,j)
      if (t(i,j) /= tnul) ss = ss + p(i,j)*p(i,j)
    enddo; enddo
    ds = a * sqrt(ss / float(mxm*mym));  n = 0;  ss = 0.
    do j=1,myf; do i=1,myf
      if (f(i,j) /= vnul) then
        r(i,j) = r(i,j) - a*q(i,j)
        ss = ss + r(i,j)*r(i,j);  n = n + 1
      endif
    enddo; enddo
    dv = sqrt(ss / float(n))
    write(6,'(a,i4,a,f8.2,a,f7.2)')   &
    ' loop', klp, '   rms.Step :', ds, '   rms.Residual :', dv
    write(9,*) klp, ds, dv
  enddo
  close(20)
  write(6,'(1x)')
  endfile(9)
  rewind(9)

  write(21,'(a8,4x,i4,4i8)') area, ncc, iorg, korg, ispa, ispb
  write(21,'(2i12,4i6,1x,f7.1,1x,f7.0,i6)')   &
    ixlm, iylm, mszx, mszy, mxm, mym, 9999.9, 0., klp
  do j=1,mym
    do i=1,mxm
      if (s(i,j) < -9999.8) s(i,j) = -9999.8
      if (s(i,j) > +9999.8) s(i,j) = +9999.8
    enddo
    write(21,'((f7.1,9(1x,f7.1)))') (s(i,j),i=1,mxm)
  enddo
  write(21,'(a8,4x,i4,4i8)') area, ncc, iorg, korg, ispa, ispb
  write(21,'(2i12,4i6,1x,f7.1,1x,f7.0)')   &
    ixlm, iylm, mszx, mszy, mxm, mym, tnul, -1.
  do j=1,mym
    write(21,'((f7.1,9(1x,f7.1)))') (t(i,j),i=1,mxm)
  enddo
  write(21,'(a2,5(1x,f7.1),1x,f7.3)') '# ', dip, dec, the, phi
  close(21)

  if (flog(ldr:ldr) /= ' ') then
    open(99,file=flog,access='append')
    write(99,'(//a)') 'AMEQS : <ameqs> inversion'
    write(99,'(a,a)') ' AM mesh data infile    : ', fnam1(1:lrtrim(fnam1))
    write(99,'(a,a)') ' CMUPS matrix infile    : ', fnam2(1:lrtrim(fnam2))
    write(99,'(a,a)') ' AMEQS model i/o file   : ', fnam3(1:lrtrim(fnam3))
    write(99,'(a,a,a)') '--------------- ', sdtm, '---------------'
    write(99,'(a12,a8,6x,a6,i4,4x,4i8)')   &
      'Areaname :  ', area, 'Coord.', ncc, iorg, korg, ispa, ispb
    write(99,'(4x,a)')   &
      '  (mesh)          xs        ys     msz-x   msz-y    mx    my    alt '
    write(99,'(4x,a12,2f10.2,2i8,2i6,a8)')   &
      'mag. obs.   ', xsf,ysf, mszxf,mszyf, mxf,myf, salt
    write(99,'(4x,a12,2f10.2,2i8,2i6,a8)')   &
      'reduc. surf.', xl, yl,  mszx,mszy, mx, my, '    --- '
    write(99,'(4x,a12,2f10.2,2i8,2i6,a8)')   &
      'eq.src.anom.', xlm,ylm, mszx,mszy, mxm,mym, '    var.'
    write(99,'(a,f6.2,a,i4,a,i4,a)')   &
      ' Half width of calc.window :', hw, ' km (', nhx, ' *', nhy, '  mesh )'
    write(99,'(a,f8.1,a)')   &
      ' Equiv.Source :', vd, ' m below Reduction alt.'
    write(99,'(a,i4)') ' Max. Loop count :', nloop
    do
      read(9,*,iostat=IER) klp, ds, dv
      if (IER < 0) exit
      write(99,'(a,i4,a,f8.2,a,f7.2)')   &
        ' loop', klp, '   rms.Step :', ds, '   rms.Residual :', dv
    enddo
    call strdtm(sdtm)
    write(99,'(a,a,a)') '=============== ', sdtm, '==============='
    close(99)
  endif
  close(9)
  stop
  end
!---
  subroutine conv1(g,nfx,nfy, s,mxm,mym, r,mx,my)
  implicit none
  integer,intent(in) :: nfx, nfy, mxm, mym, mx, my
  real,intent(inout) :: g(nfx,nfy)
  real,intent(in) :: s(mxm,mym)
  real,intent(out) :: r(mx,my)
  character(8) :: area
  integer :: nhx, nhy, i, j, ip, jp, k, ic, jc, kis, kjs, is, js
  real :: rp

  nhx = (nfx-1) / 2;  nhy = (nfy-1) / 2
  call dpcini('... read CMUPS matrix (1) : ')
  read(20) area, (i,k=1,23)
  do jp=1,my; do ip=1,mx
    read(20) k,k, ic, jc, g
    rp = 0.;  kis = ic - nhx;  kjs = jc - nhy
    do j=1,nfy
      js = kjs + j;  if ((js <= 0) .or. (js > mym)) cycle
      do i=1,nfx
        is = kis + i;  if ((is <= 0) .or. (is > mxm)) cycle
        rp = rp + g(i,j)*s(is,js)
      enddo
    enddo
    r(ip,jp) = rp
    call dpcent((jp-1)*mx+ip, mx*my)
  enddo; enddo
  rewind(20)
  return
  end subroutine
!---
  subroutine conv2(g,nfx,nfy, r,mx,my, s,mxm,mym)
  implicit none
  integer,intent(in) :: nfx, nfy, mx, my, mxm, mym
  real,intent(inout) :: g(nfx,nfy)
  real,intent(in) :: r(mx,my)
  real,intent(out) :: s(mxm,mym)
  character(8) :: area
  integer :: nhx, nhy, i, j, ip, jp, k, is, js, ic, jc, kis, kjs

  nhx = (nfx-1) / 2;  nhy = (nfy-1) / 2
  call dpcini('... read CMUPS matrix (2) : ')
  read(20) area, (i,k=1,23)
  do js=1,mym; do is=1,mxm;  s(is,js) = 0.;  enddo; enddo
  do jp=1,my; do ip=1,mx
    read(20) k,k, ic, jc, g
    kis = ic - nhx;  kjs = jc - nhy; 
    do j=1,nfy
      js = kjs + j;  if ((js <= 0) .or. (js > mym)) cycle
      do i=1,nfx
        is = kis + i;  if ((is <= 0) .or. (is > mxm)) cycle
        s(is,js) = s(is,js) + g(i,j)*r(ip,jp)
      enddo
    enddo
    call dpcent((jp-1)*mx+ip, mx*my)
  enddo; enddo
  rewind(20)
  return
  end subroutine
